Index: code/branches/questsystem5/src/orxonox/objects/quest/AddQuest.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/AddQuest.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/AddQuest.cc	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file AddQuest.cc
     @brief Implementation of the AddQuest class.
 */
@@ -42,4 +42,5 @@
 #include "orxonox/objects/infos/PlayerInfo.h"
 #include "QuestManager.h"
+#include "QuestDescription.h";
 #include "Quest.h"
 
Index: code/branches/questsystem5/src/orxonox/objects/quest/AddQuest.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/AddQuest.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/AddQuest.h	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file AddQuest.h
     @brief Definition of the AddQuest class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/AddQuestHint.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/AddQuestHint.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/AddQuestHint.cc	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file AddQuestHint.cc
     @brief Implementation of the AddQuestHint class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/AddQuestHint.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/AddQuestHint.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/AddQuestHint.h	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file AddQuestHint.h
     @brief Definition of the AddQuestHint class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/AddReward.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/AddReward.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/AddReward.cc	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file AddReward.cc
     @brief Implementation of the AddReward class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/AddReward.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/AddReward.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/AddReward.h	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file AddReward.h
     @brief Definition of the AddReward class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/CMakeLists.txt
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/CMakeLists.txt	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/CMakeLists.txt	(revision 2779)
@@ -16,4 +16,5 @@
   QuestListener.cc
   QuestManager.cc
+  QuestNotification.cc
   Rewardable.cc
 )
Index: code/branches/questsystem5/src/orxonox/objects/quest/ChangeQuestStatus.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/ChangeQuestStatus.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/ChangeQuestStatus.cc	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file ChangeQuestStatus.cc
     @brief Implementation of the ChangeQuestStatus class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/ChangeQuestStatus.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/ChangeQuestStatus.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/ChangeQuestStatus.h	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file ChangeQuestStatus.h
     @brief Definition of the ChangeQuestStatus class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/CompleteQuest.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/CompleteQuest.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/CompleteQuest.cc	(revision 2779)
@@ -28,5 +28,5 @@
  
 /**
-    @file
+    @file CompleteQuest.cc
     @brief Implementation of the CompleteQuest class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/CompleteQuest.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/CompleteQuest.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/CompleteQuest.h	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file CompleteQuest.h
     @brief Definition of the CompleteQuest class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/FailQuest.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/FailQuest.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/FailQuest.cc	(revision 2779)
@@ -28,5 +28,5 @@
  
 /**
-    @file
+    @file FailQuest.cc
     @brief Implementation of the FailQuest class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/FailQuest.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/FailQuest.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/FailQuest.h	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file FailQuest.h
     @brief Definition of the FailQuest class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/GlobalQuest.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/GlobalQuest.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/GlobalQuest.cc	(revision 2779)
@@ -28,5 +28,5 @@
  
 /**
-    @file
+    @file GlobalQuest.cc
     @brief Implementation of the GlobalQuest class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/GlobalQuest.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/GlobalQuest.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/GlobalQuest.h	(revision 2779)
@@ -28,5 +28,5 @@
  
 /**
-    @file
+    @file GlobalQuest.h
     @brief Definition of the GlobalQuest class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/LocalQuest.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/LocalQuest.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/LocalQuest.cc	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file LocalQuest.cc
     @brief Implementation of the LocalQuest class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/LocalQuest.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/LocalQuest.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/LocalQuest.h	(revision 2779)
@@ -28,5 +28,5 @@
  
 /**
-    @file
+    @file LocalQuest.h
     @brief Definition of the LocalQuest class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/Quest.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/Quest.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/Quest.cc	(revision 2779)
@@ -28,5 +28,5 @@
  
 /**
-    @file
+    @file Quest.cc
     @brief Implementation of the Quest class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/Quest.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/Quest.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/Quest.h	(revision 2779)
@@ -28,5 +28,5 @@
  
 /**
-    @file
+    @file Quest.h
     @brief Definition of the Quest class.
         The Quest is the parent class of LocalQuest and GlobalQuest.
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestDescription.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestDescription.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestDescription.cc	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file QuestDescription.cc
     @brief Implementation of the QuestDescription class.
 */
@@ -37,5 +37,5 @@
 
 #include "core/CoreIncludes.h"
-#include "orxonox/overlays/notifications/Notification.h"
+#include "QuestNotification.h"
 
 namespace orxonox
@@ -89,13 +89,13 @@
     @return
         Returns true if successful.
+    @todo
+        Make sure the messages meet the conditions.
     */
     bool QuestDescription::notificationHelper(const std::string & item, const std::string & status) const
     {
         std::string message = "";
-        std::string title = "";
         if(item == "hint")
         {
-            title = "You received a hint: '" + this->title_ + "'";
-            message = this->description_;
+            message = "You received a hint: '" + this->title_ + "'";
         }
         else if(item == "quest")
@@ -103,16 +103,13 @@
             if(status == "start")
             {
-                title = "You received a new quest: '" + this->title_ + "'";
-                message = this->description_;
+                message = "You received a new quest: '" + this->title_ + "'";
             }
             else if(status == "fail")
             {
-                title = "You failed the quest: '" + this->title_ + "'";
-                message = this->failMessage_;
+                message = "You failed the quest: '" + this->title_ + "'";
             }
             else if(status == "complete")
             {
-                title = "You successfully completed the quest: '" + this->title_ + "'";
-                message = this->completeMessage_;
+                message = "You successfully completed the quest: '" + this->title_ + "'";
             }
             else
@@ -128,5 +125,5 @@
         }
         
-        Notification* notification = new Notification(0, message, title, 30);
+        QuestNotification* notification = new QuestNotification(message);
         notification->send();
         return true;
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestDescription.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestDescription.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestDescription.h	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file QuestDescription.h
     @brief Definition of the QuestDescription class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestEffect.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestEffect.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestEffect.cc	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file QuestEffect.cc
     @brief Implementation of the QuestEffect class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestEffect.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestEffect.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestEffect.h	(revision 2779)
@@ -28,5 +28,5 @@
  
 /**
-    @file
+    @file QuestEffect.h
     @brief Definition of the QuestEffect class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestEffectBeacon.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestEffectBeacon.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestEffectBeacon.cc	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file QuestEffectBeacon.cc
     @brief Implementation of the QuestEffectBeacon class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestEffectBeacon.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestEffectBeacon.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestEffectBeacon.h	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file QuestEffectBeacon.h
     @brief Definition of the QuestEffectBeacon class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestHint.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestHint.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestHint.cc	(revision 2779)
@@ -28,5 +28,5 @@
  
 /**
-    @file
+    @file QuestHint.cc
     @brief Implementation of the QuestHint class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestHint.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestHint.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestHint.h	(revision 2779)
@@ -28,5 +28,5 @@
  
 /**
-    @file
+    @file QuestHint.h
     @brief Definition of the QuestHint class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestItem.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestItem.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestItem.cc	(revision 2779)
@@ -28,5 +28,5 @@
  
 /**
-    @file
+    @file QuestItem.cc
     @brief Implementation of the QuestItem class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestItem.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestItem.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestItem.h	(revision 2779)
@@ -28,5 +28,5 @@
  
 /**
-    @file
+    @file QuestItem.h
     @brief Definition of the QuestItem class.
         The QuestItem is the parent class of Quest and QuestHint.
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestListener.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestListener.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestListener.cc	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file QuestListener.cc
     @brief Implementation of the QuestListener class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestListener.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestListener.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestListener.h	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file QuestListener.h
     @brief Definition of the QuestListener class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestManager.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestManager.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestManager.cc	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file QuestManager.cc
     @brief Implementation of the QuestManager class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestManager.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestManager.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestManager.h	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file QuestManager.h
     @brief Definition of the QuestManager class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestNotification.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestNotification.cc	(revision 2779)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestNotification.cc	(revision 2779)
@@ -0,0 +1,66 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See thes
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Damian 'Mozork' Frick
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "QuestNotification.h"
+
+#include "core/CoreIncludes.h"
+
+#include "orxonox/overlays/notifications/Notification.h"
+
+namespace orxonox {
+
+    const std::string QuestNotification::SENDER = "questsystem";
+
+    QuestNotification::QuestNotification(BaseObject* creator) : Notification(creator)
+    {
+        this->initialize();
+    }
+    
+    QuestNotification::QuestNotification(const std::string & message) : Notification(message)
+    {
+        this->initialize();
+    }
+    
+    QuestNotification::~QuestNotification()
+    {
+        
+    }
+
+    bool QuestNotification::send(void)
+    {
+        return this->Notification::send(QuestNotification::SENDER);
+    }
+
+    void QuestNotification::initialize(void)
+    {
+        RegisterObject(QuestNotification);
+    }
+
+
+}
Index: code/branches/questsystem5/src/orxonox/objects/quest/QuestNotification.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/QuestNotification.h	(revision 2779)
+++ code/branches/questsystem5/src/orxonox/objects/quest/QuestNotification.h	(revision 2779)
@@ -0,0 +1,64 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See thes
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Damian 'Mozork' Frick
+ *   Co-authors:
+ *      ...
+ *
+ */
+ 
+#ifndef _QuestNotification_H__
+#define _QuestNotification_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include <string>
+
+#include "orxonox/overlays/notifications/Notification.h"
+
+namespace orxonox {
+
+    /**
+    @brief
+        
+    @author
+        Damian 'Mozork' Frick
+    */
+    class _OrxonoxExport QuestNotification : public Notification
+    {
+        public:
+            QuestNotification(BaseObject* creator);
+            QuestNotification(const std::string & message);
+            virtual ~QuestNotification();
+            
+            bool send(void);
+     
+        private:
+            static const std::string SENDER;
+            
+            void initialize(void);
+ 
+    };
+
+}
+
+#endif /* _QuestNotification_H__ */
Index: code/branches/questsystem5/src/orxonox/objects/quest/Rewardable.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/Rewardable.cc	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/Rewardable.cc	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file Rewardable.cc
     @brief Implementation of the Rewardable class.
 */
Index: code/branches/questsystem5/src/orxonox/objects/quest/Rewardable.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/Rewardable.h	(revision 2777)
+++ code/branches/questsystem5/src/orxonox/objects/quest/Rewardable.h	(revision 2779)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file Rewardable.h
     @brief Definition of the Rewardable class.
 */